-#!/bin/bash
-
-# Copyright 2002 hp Information Technologies Group, L.P.
-#
-# See "man chkconfig" for information on next two lines (Red Hat only)
-# chkconfig: - 2345 91 1
-# description: HP Advanced System Management Drivers and Agents for Linux
-#
-#
-# Following lines are in conformance with LSB 1.2 spec
+#! /bin/sh
### BEGIN INIT INFO
# Provides: hpasm
# Required-Start: snmp
# Required-Stop: hprsm cmanic cmastor
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
-# Description: starts hpasm (HP Advanced System Management Drivers and Agents)
+# Description: starts hpasmd (HP Advanced System Management Drivers and Agents)
### END INIT INFO
-RETVAL=0
-SCRIPT=/opt/compaq/hpasm/etc/hpasm
+# Author: Matthijs Kooijman <matthijs@stdin.nl>
+# This file is mostly built from the skeleton, but with PIDFILE and VERBOSE
+# stuff removed.. It starts hpasmd, without any extra crap or configs.
+
+# Just hpasmd is enough to be able to use hpasmcli and hplog, to send ASR pings
+# and to shutdown the system in case of thermal failure.
+
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="HP Advanced System Management Daemon"
+NAME=hpasmd
+DAEMON=/opt/compaq/hpasmd/bin/hpasmd
+DAEMON_ARGS=""
+SCRIPTNAME=/etc/init.d/$NAME
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
+. /lib/lsb/init-functions
-ACTION=$1
-shift
-ADDARGS=$*
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+ # Return
+ # 0 if daemon has been started
+ # 1 if daemon was already running
+ # 2 if daemon could not be started
+ start-stop-daemon --start --quiet --exec $DAEMON --test > /dev/null \
+ || return 1
+ start-stop-daemon --start --quiet --exec $DAEMON -- $DAEMON_ARGS \
+ || return 2
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+ # Return
+ # 0 if daemon has been stopped
+ # 1 if daemon was already stopped
+ # 2 if daemon could not be stopped
+ # other if a failure occurred
+ start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --name $NAME
+ RETVAL="$?"
+ return "$RETVAL"
+}
-# See how we were called.
-case "$ACTION" in
+case "$1" in
start)
- $SCRIPT start $ADDARGS
+ log_daemon_msg "Starting $DESC" "$NAME"
+ do_start
+ case "$?" in
+ 0|1) log_end_msg 0 ;;
+ 2) log_end_msg 1 ;;
+ esac
;;
stop)
- $SCRIPT stop $ADDARGS
+ log_daemon_msg "Stopping $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1) log_end_msg 0 ;;
+ 2) log_end_msg 1 ;;
+ esac
;;
- restart)
- $SCRIPT stop $ADDARGS
- $SCRIPT start $ADDARGS
- ;;
- status)
- $SCRIPT status $ADDARGS
- ;;
- configure)
- $SCRIPT configure $ADDARGS
- ;;
- reconfigure)
- $SCRIPT reconfigure $ADDARGS
- ;;
- unconfigure)
- $SCRIPT unconfigure $ADDARGS
+ restart|force-reload)
+ #
+ # If the "reload" option is implemented then remove the
+ # 'force-reload' alias
+ #
+ log_daemon_msg "Restarting $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1)
+ do_start
+ case "$?" in
+ 0) log_end_msg 0 ;;
+ 1) log_end_msg 1 ;; # Old process is still running
+ *) log_end_msg 1 ;; # Failed to start
+ esac
+ ;;
+ *)
+ # Failed to stop
+ log_end_msg 1
+ ;;
+ esac
;;
*)
- # do not advertise unreasonable commands that there is no reason
- # to use with this device
- echo "Usage: hpasm {start|stop|status|restart|configure|unconfigure|reconfigure}"
- exit 1
+ #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
+ echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
+ exit 3
+ ;;
esac
-exit 0
+: